#ifndef _OCULUSSPATIALIZERSETTINGS_H_
#define _OCULUSSPATIALIZERSETTINGS_H_


#ifndef OVRA_FMOD_EXPORT
#  ifdef _WIN32
#    define OVRA_FMOD_EXPORT __declspec( dllexport )
#  elif defined __APPLE__ 
#    define OVRA_FMOD_EXPORT 
#  elif defined __linux__
#    define OVRA_FMOD_EXPORT __attribute__((visibility("default")))
#  else
#    error not implemented
#  endif
#endif

#include <stdint.h>

#ifndef OVR_RESULT_DEFINED
#define OVR_RESULT_DEFINED
typedef int32_t ovrResult;
#endif

/// A 3D vector with float components.
typedef struct ospFmodVector3f_
{
    float x, y, z;
} ospFmodVector3f;

extern "C"
{

OVRA_FMOD_EXPORT ovrResult OSP_FMOD_Initialize(int SampleRate, int BufferLength);
OVRA_FMOD_EXPORT ovrResult OSP_FMOD_SetProfilerEnabled(bool enabled);

typedef void(*OSP_FMOD_RAYCAST_CALLBACK)(ospFmodVector3f origin, ospFmodVector3f direction, ospFmodVector3f* hit, ospFmodVector3f* normal);
OVRA_FMOD_EXPORT ovrResult OSP_FMOD_AssignRaycastCallback(OSP_FMOD_RAYCAST_CALLBACK callback);


}


#endif // _OCULUSSPATIALIZERSETTINGS_H_